Index: trunk/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OFF_SRC/dtadyn.F90	(revision 2528)
@@ -519,13 +432,12 @@
       qsrdta (:,:,2)  = zqsr(:,:) * tmask(:,:,1)
       hmlddta(:,:,2)  = zmld(:,:) * tmask(:,:,1)
-      
-#if defined key_trcbbl_dif   ||   defined key_trcbbl_adv
-      bblxdta(:,:,2) = MAX( 0., zbblx(:,:) )
-      bblydta(:,:,2) = MAX( 0., zbbly(:,:) )
-
-      WHERE( bblxdta(:,:,2) > 2. ) bblxdta(:,:,2) = 0.
-      WHERE( bblydta(:,:,2) > 2. ) bblydta(:,:,2) = 0.
-#endif
-
+
+      IF( l_offbbl ) THEN 
+         bblxdta(:,:,2) = MAX( 0., zbblx(:,:) )
+         bblydta(:,:,2) = MAX( 0., zbbly(:,:) )
+         WHERE( bblxdta(:,:,2) > 2. ) bblxdta(:,:,2) = 0.
+         WHERE( bblydta(:,:,2) > 2. ) bblydta(:,:,2) = 0.
+      ENDIF
+      
       IF( kt == nitend ) THEN
          CALL iom_close ( numfl_t )
@@ -534,7 +446,8 @@
          CALL iom_close ( numfl_w )
       ENDIF
-      
+      !      
    END SUBROUTINE dynrea
 
+
    SUBROUTINE dta_dyn_init
       !!----------------------------------------------------------------------
@@ -544,18 +457,8 @@
       !!
       !! ** Method :
-      !!
-      !! History :
-      !!    ! original  : 92-01 (M. Imbard: sub domain)
-      !!    ! 98-04 (L.Bopp MA Foujols: slopes for isopyc.)
-      !!    ! 98-05 (L. Bopp read output of coupled run)
-      !!    ! 05-03 (O. Aumont and A. El Moussaoui) F90
-      !!----------------------------------------------------------------------
-      !! * Modules used
-
-      !! * Local declarations
-
+      !!----------------------------------------------------------------------
       REAL(wp) ::   znspyr   !: number of time step per year
-
-      NAMELIST/namdyn/ ndtadyn, ndtatot, nsptint, nficdyn, lperdyn,  &
+      !!
+      NAMELIST/namdyn/ ndtadyn, ndtatot, nsptint, lperdyn,  &
       &                cfile_grid_T, cfile_grid_U, cfile_grid_V, cfile_grid_W
       !!----------------------------------------------------------------------
@@ -564,9 +467,8 @@
       ! ======================================
 
-      ! Read Namelist namdyn : Lateral physics on tracers
-      REWIND( numnam )
+      REWIND( numnam )              ! Read Namelist namdyn : Lateral physics on tracers
       READ  ( numnam, namdyn )
 
-      IF(lwp) THEN
+      IF(lwp) THEN                  ! control print
          WRITE(numout,*)
          WRITE(numout,*) 'namdyn : offline dynamical selection'
@@ -577,5 +479,4 @@
          WRITE(numout,*) ' total number of elements in the FILE       ndtatot = ' , ndtatot
          WRITE(numout,*) ' type of interpolation                      nsptint = ' , nsptint
-         WRITE(numout,*) ' number of dynamics FILE                    nficdyn = ' , nficdyn
          WRITE(numout,*) ' loop on the same FILE                      lperdyn = ' , lperdyn
          WRITE(numout,*) '  '
@@ -586,11 +487,14 @@
          WRITE(numout,*) ' '
       ENDIF
-
+      !
       znspyr   = nyear_len(1) * rday / rdt  
       rnspdta  = znspyr / FLOAT( ndtadyn )
       rnspdta2 = rnspdta * 0.5 
-
+      !
+      CALL dta_dyn( nit000 )
+      !
    END SUBROUTINE dta_dyn_init
 
+
    SUBROUTINE wzv( pu, pv, pw, phdiv )
       !!----------------------------------------------------------------------
@@ -599,29 +503,20 @@
       !! ** Purpose :   Compute the now vertical velocity after the array swap
       !!
-      !! ** Method  :
-      !! ** Method  : - Divergence:
-      !!      - compute the now divergence given by :
-      !!         * z-coordinate
+      !! ** Method  : - compute the now divergence given by :
+      !!         * z-coordinate ONLY !!!!
       !!         hdiv = 1/(e1t*e2t) [ di(e2u  u) + dj(e1v  v) ]
       !!     - Using the incompressibility hypothesis, the vertical
       !!      velocity is computed by integrating the horizontal divergence
       !!      from the bottom to the surface.
-      !!        The boundary conditions are w=0 at the bottom (no flux) and,
-      !!      in regid-lid case, w=0 at the sea surface.
-      !!
-      !!
-      !! History :
-      !!   9.0  !  02-07  (G. Madec)  Vector optimization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in  )   :: pu, pv    !:  horizontal velocities
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( out )   :: pw        !:  verticla velocity
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) :: phdiv     !:  horizontal divergence
-
-      !! * Local declarations
+      !!        The boundary conditions are w=0 at the bottom (no flux).
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) :: pu, pv    !:  horizontal velocities
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) :: pw        !:  verticla velocity
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) :: phdiv     !:  horizontal divergence
+      !!
       INTEGER  ::  ji, jj, jk
       REAL(wp) ::  zu, zu1, zv, zv1, zet
-
-
+      !!----------------------------------------------------------------------
+      !
       ! Computation of vertical velocity using horizontal divergence
       phdiv(:,:,:) = 0.
@@ -629,11 +524,4 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zu  = pu(ji  ,jj  ,jk) * umask(ji  ,jj  ,jk) * e2u(ji  ,jj  )
-               zu1 = pu(ji-1,jj  ,jk) * umask(ji-1,jj  ,jk) * e2u(ji-1,jj  )
-               zv  = pv(ji  ,jj  ,jk) * vmask(ji  ,jj  ,jk) * e1v(ji  ,jj  )
-               zv1 = pv(ji  ,jj-1,jk) * vmask(ji  ,jj-1,jk) * e1v(ji  ,jj-1)
-               zet = 1. / ( e1t(ji,jj) * e2t(ji,jj) )
-#else
                zu  = pu(ji  ,jj  ,jk) * umask(ji  ,jj  ,jk) * e2u(ji  ,jj  ) * fse3u(ji  ,jj  ,jk)
                zu1 = pu(ji-1,jj  ,jk) * umask(ji-1,jj  ,jk) * e2u(ji-1,jj  ) * fse3u(ji-1,jj  ,jk)
@@ -641,21 +529,51 @@
                zv1 = pv(ji  ,jj-1,jk) * vmask(ji  ,jj-1,jk) * e1v(ji  ,jj-1) * fse3v(ji  ,jj-1,jk)
                zet = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-#endif
                phdiv(ji,jj,jk) = ( zu - zu1 + zv - zv1 ) * zet 
             END DO
          END DO
-      ENDDO
-
-      ! Lateral boundary conditions on phdiv
-      CALL lbc_lnk( phdiv, 'T', 1. )
-
-
+      END DO
+      CALL lbc_lnk( phdiv, 'T', 1. )      ! Lateral boundary conditions on phdiv
+      !
       ! computation of vertical velocity from the bottom
-      pw(:,:,jpk) = 0.
+      pw(:,:,jpk) = 0._wp
       DO jk = jpkm1, 1, -1
          pw(:,:,jk) = pw(:,:,jk+1) - fse3t(:,:,jk) * phdiv(:,:,jk)
       END DO
-
+      !
    END SUBROUTINE wzv
+
+
+   SUBROUTINE dta_eiv( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE dta_eiv  ***
+      !!
+      !! ** Purpose :   Compute the eddy induced velocity coefficient from the
+      !!      growth rate of baroclinic instability.
+      !!
+      !! ** Method : Specific to the offline model. Computes the horizontal
+      !!             values from the vertical value
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt     ! ocean time-step inedx
+      !!
+      INTEGER ::   ji, jj           ! dummy loop indices
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'dta_eiv : eddy induced velocity coefficients'
+         IF(lwp) WRITE(numout,*) '~~~~~~~'
+      ENDIF
+      !
+      ! Average the diffusive coefficient at u- v- points
+      DO jj = 2, jpjm1
+         DO ji = fs_2, fs_jpim1   ! vector opt.
+            aeiu(ji,jj) = .5 * ( aeiw(ji,jj) + aeiw(ji+1,jj  ) )
+            aeiv(ji,jj) = .5 * ( aeiw(ji,jj) + aeiw(ji  ,jj+1) )
+         END DO
+      END DO
+      CALL lbc_lnk( aeiu, 'U', 1. )   ;   CALL lbc_lnk( aeiv, 'V', 1. )    ! lateral boundary condition
+      !
+   END SUBROUTINE dta_eiv
+
 
    SUBROUTINE tau2wnd( ptaux, ptauy, pwspd )
@@ -667,13 +585,11 @@
       !! ** Method  : |tau|=rhoa*Cd*|U|^2
       !!---------------------------------------------------------------------
-      !! * Arguments
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( in  ) ::  &
-         ptaux, ptauy                              !: wind stress in i-j direction resp.
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( out ) ::  &
-         pwspd                                     !: wind speed 
-      REAL(wp) ::   zrhoa  = 1.22         ! Air density kg/m3
-      REAL(wp) ::   zcdrag = 1.5e-3       ! drag coefficient
-      REAL(wp) ::   ztx, zty, ztau, zcoef ! temporary variables
-      INTEGER  ::   ji, jj                ! dummy indices
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   ptaux, ptauy   ! wind stress in i-j direction resp.
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(  out) ::   pwspd          ! wind speed
+      !! 
+      REAL(wp) ::   zrhoa  = 1.22_wp       ! Air density kg/m3
+      REAL(wp) ::   zcdrag = 1.5e-3_wp     ! drag coefficient
+      REAL(wp) ::   ztx, zty, ztau, zcoef  ! temporary variables
+      INTEGER  ::   ji, jj                 ! dummy indices
       !!---------------------------------------------------------------------
       zcoef = 1. / ( zrhoa * zcdrag )
@@ -689,185 +605,7 @@
       END DO
       CALL lbc_lnk( pwspd(:,:), 'T', 1. )
-
+      !
    END SUBROUTINE tau2wnd
 
-#if defined key_trcbbl_dif   ||   defined key_trcbbl_adv
-
-   SUBROUTINE bbl_sign( ptn, psn, pbblx, pbbly )
-      !!----------------------------------------------------------------------
-      !!                    ***  ROUTINE bbl_sign  ***
-      !!
-      !! ** Purpose :   Compute the sign of local gradient of density multiplied by the slope
-      !!                along the bottom slope gradient : grad( rho) * grad(h)
-      !!                Need to compute the diffusive bottom boundary layer
-      !!
-      !! ** Method  :   When the product grad( rho) * grad(h) < 0 (where grad
-      !!      is an along bottom slope gradient) an additional lateral diffu-
-      !!      sive trend along the bottom slope is added to the general tracer
-      !!      trend, otherwise nothing is done. See trcbbl.F90
-      !!
-      !!
-      !! History :
-      !!   9.0  !  02-07  (G. Madec)  Vector optimization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in  ) ::  &
-         ptn             ,  &                           !: temperature 
-         psn                                            !: salinity 
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( out ) ::  &
-         pbblx , pbbly                                  !: sign of bbl in i-j direction resp. 
-      
-      !! * Local declarations
-      INTEGER  ::   ji, jj                   ! dummy loop indices
-      INTEGER  ::   ik
-      REAL(wp) ::   &
-         ztx, zsx, zhx, zalbetx, zgdrhox,     &  ! temporary scalars
-         zty, zsy, zhy, zalbety, zgdrhoy 
-      REAL(wp), DIMENSION(jpi,jpj) ::    &
-        ztnb, zsnb, zdep
-      REAL(wp) ::    fsalbt, pft, pfs, pfh   ! statement function
-      !!----------------------------------------------------------------------
-      ! ratio alpha/beta
-      ! ================
-      !  fsalbt: ratio of thermal over saline expension coefficients
-      !       pft :  potential temperature in degrees celcius
-      !       pfs :  salinity anomaly (s-35) in psu
-      !       pfh :  depth in meters
-
-      fsalbt( pft, pfs, pfh ) =                                              &
-         ( ( ( -0.255019e-07 * pft + 0.298357e-05 ) * pft                    &
-                                   - 0.203814e-03 ) * pft                    &
-                                   + 0.170907e-01 ) * pft                    &
-                                   + 0.665157e-01                            &
-         +(-0.678662e-05 * pfs - 0.846960e-04 * pft + 0.378110e-02 ) * pfs   &
-         +  ( ( - 0.302285e-13 * pfh                                         &
-                - 0.251520e-11 * pfs                                         &
-                + 0.512857e-12 * pft * pft          ) * pfh                  &
-                                     - 0.164759e-06   * pfs                  &
-             +(   0.791325e-08 * pft - 0.933746e-06 ) * pft                  &
-                                     + 0.380374e-04 ) * pfh
-
-      ! 0. 2D fields of bottom temperature and salinity, and bottom slope
-      ! -----------------------------------------------------------------
-      ! mbathy= number of w-level, minimum value=1 (cf domrea.F90)
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-#  endif
-            ik          =  MAX( mbathy(ji,jj) - 1, 1 )    ! vertical index of the bottom ocean T-level
-            ztnb(ji,jj) = ptn(ji,jj,ik) * tmask(ji,jj,1)  ! masked T and S at ocean bottom
-            zsnb(ji,jj) = psn(ji,jj,ik) * tmask(ji,jj,1)
-            zdep(ji,jj) = fsdept(ji,jj,ik)                ! depth of the ocean bottom T-level
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-      !!----------------------------------------------------------------------
-      ! 1. Criteria of additional bottom diffusivity: grad(rho).grad(h)<0
-      ! --------------------------------------------
-      ! Sign of the local density gradient along the i- and j-slopes
-      ! multiplied by the slope of the ocean bottom
-
-      SELECT CASE ( neos )
-
-      CASE ( 0 )                 ! Jackett and McDougall (1994) formulation
-
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif
-            ! temperature, salinity anomalie and depth
-            ztx = 0.5 * ( ztnb(ji,jj) + ztnb(ji+1,jj) )
-            zsx = 0.5 * ( zsnb(ji,jj) + zsnb(ji+1,jj) ) - 35.0
-            zhx = 0.5 * ( zdep(ji,jj) + zdep(ji+1,jj) )
-            !
-            zty = 0.5 * ( ztnb(ji,jj+1) + ztnb(ji,jj) )
-            zsy = 0.5 * ( zsnb(ji,jj+1) + zsnb(ji,jj) ) - 35.0
-            zhy = 0.5 * ( zdep(ji,jj+1) + zdep(ji,jj) )
-            ! masked ratio alpha/beta
-            zalbetx = fsalbt( ztx, zsx, zhx ) * umask(ji,jj,1)
-            zalbety = fsalbt( zty, zsy, zhy ) * vmask(ji,jj,1)
-            ! local density gradient along i-bathymetric slope
-            zgdrhox = zalbetx * ( ztnb(ji+1,jj) - ztnb(ji,jj) )   &
-                   -            ( zsnb(ji+1,jj) - zsnb(ji,jj) )
-            ! local density gradient along j-bathymetric slope
-            zgdrhoy = zalbety * ( ztnb(ji,jj+1) - ztnb(ji,jj) )   &
-                   -            ( zsnb(ji,jj+1) - zsnb(ji,jj) )
-            ! sign of local i-gradient of density multiplied by the i-slope
-            pbblx(ji,jj) = 0.5 - SIGN( 0.5, -zgdrhox * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            ! sign of local j-gradient of density multiplied by the j-slope
-            pbbly(ji,jj) = 0.5 - SIGN( 0.5, -zgdrhoy * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-      CASE ( 1 )               ! Linear formulation function of temperature only
-                               !
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif
-            ! local 'density/temperature' gradient along i-bathymetric slope
-            zgdrhox =  ztnb(ji+1,jj) - ztnb(ji,jj)
-            ! local density gradient along j-bathymetric slope
-            zgdrhoy =  ztnb(ji,jj+1) - ztnb(ji,jj)
-            ! sign of local i-gradient of density multiplied by the i-slope
-            pbblx(ji,jj) = 0.5 - SIGN( 0.5, -zgdrhox * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            ! sign of local j-gradient of density multiplied by the j-slope
-            pbbly(ji,jj) = 0.5 - SIGN( 0.5, -zgdrhoy * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-      CASE ( 2 )               ! Linear formulation function of temperature and salinity
-
-#  if defined key_vectopt_loop
-      jj = 1
-      DO ji = 1, jpij-jpi   ! vector opt. (forced unrolling)
-#  else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-#  endif     
-            ! local density gradient along i-bathymetric slope
-            zgdrhox = - ( rbeta*( zsnb(ji+1,jj) - zsnb(ji,jj) )   &
-                      -  ralpha*( ztnb(ji+1,jj) - ztnb(ji,jj) ) )
-            ! local density gradient along j-bathymetric slope
-            zgdrhoy = - ( rbeta*( zsnb(ji,jj+1) - zsnb(ji,jj) )   &
-                      -  ralpha*( ztnb(ji,jj+1) - ztnb(ji,jj) ) )
-            ! sign of local i-gradient of density multiplied by the i-slope
-            pbblx(ji,jj) = 0.5 - SIGN( 0.5, - zgdrhox * ( zdep(ji+1,jj) - zdep(ji,jj) ) )
-            ! sign of local j-gradient of density multiplied by the j-slope
-            pbbly(ji,jj) = 0.5 - SIGN( 0.5, -zgdrhoy * ( zdep(ji,jj+1) - zdep(ji,jj) ) )
-#  if ! defined key_vectopt_loop
-         END DO
-#  endif
-      END DO
-
-      CASE DEFAULT
-
-         WRITE(ctmp1,*) '          bad flag value for neos = ', neos
-         CALL ctl_stop(ctmp1)
-
-      END SELECT
-   
-      ! Lateral boundary conditions
-      CALL lbc_lnk( pbblx, 'U', 1. )
-      CALL lbc_lnk( pbbly, 'V', 1. )
-
-   END SUBROUTINE bbl_sign
-
-#endif
 
    SUBROUTINE swap_dyn_data
@@ -876,10 +614,6 @@
       !!
       !! ** Purpose :   swap array data
-      !!
-      !! History :
-      !!   9.0  !  07-09  (C. Ethe)
-      !!----------------------------------------------------------------------
-
-
+      !!----------------------------------------------------------------------
+      !
       ! swap from record 2 to 1
       tdta   (:,:,:,1) = tdta   (:,:,:,2)
@@ -889,9 +623,5 @@
       vdta   (:,:,:,1) = vdta   (:,:,:,2)
       wdta   (:,:,:,1) = wdta   (:,:,:,2)
-#if defined key_trc_diatrd
-      hdivdta(:,:,:,1) = hdivdta(:,:,:,2)
-#endif
-
-#if defined key_ldfslp
+#if defined key_ldfslp && ! defined key_c1d
       uslpdta (:,:,:,1) = uslpdta (:,:,:,2)
       vslpdta (:,:,:,1) = vslpdta (:,:,:,2)
@@ -904,17 +634,18 @@
       empdta (:,:,1) = empdta (:,:,2) 
       qsrdta (:,:,1) = qsrdta (:,:,2) 
-
-#if ! defined key_off_degrad && defined key_traldf_c2d
-      ahtwdta(:,:,1) = ahtwdta(:,:,2)
-#  if defined key_trcldf_eiv
+      IF( l_offbbl ) THEN
+         bblxdta(:,:,1) = bblxdta(:,:,2)
+         bblydta(:,:,1) = bblydta(:,:,2) 
+      ENDIF
+
+#if ! defined key_degrad && defined key_traldf_c2d && defined key_traldf_eiv
       aeiwdta(:,:,1) = aeiwdta(:,:,2)
-#  endif
-#endif
-
-#if defined key_off_degrad
+#endif
+
+#if defined key_degrad
       ahtudta(:,:,:,1) = ahtudta(:,:,:,2)
       ahtvdta(:,:,:,1) = ahtvdta(:,:,:,2)
       ahtwdta(:,:,:,1) = ahtwdta(:,:,:,2)
-#  if defined key_trcldf_eiv
+#  if defined key_traldf_eiv
       aeiudta(:,:,:,1) = aeiudta(:,:,:,2)
       aeivdta(:,:,:,1) = aeivdta(:,:,:,2)
@@ -922,11 +653,7 @@
 #  endif
 #endif
-
-#if defined key_trcbbl_dif || defined key_trcbbl_adv
-      bblxdta(:,:,1) = bblxdta(:,:,2)
-      bblydta(:,:,1) = bblydta(:,:,2)
-#endif
-
+      !
    END SUBROUTINE swap_dyn_data
+
 
    SUBROUTINE assign_dyn_data
@@ -939,22 +666,13 @@
       !!----------------------------------------------------------------------
       
-      tn (:,:,:) = tdta  (:,:,:,2)
-      sn (:,:,:) = sdta  (:,:,:,2)
-      avt(:,:,:) = avtdta(:,:,:,2)
+      tsn(:,:,:,jp_tem) = tdta  (:,:,:,2)
+      tsn(:,:,:,jp_sal) = sdta  (:,:,:,2)
+      avt(:,:,:)        = avtdta(:,:,:,2)
       
       un (:,:,:) = udta  (:,:,:,2) 
       vn (:,:,:) = vdta  (:,:,:,2)
       wn (:,:,:) = wdta  (:,:,:,2)
-
-#if defined key_trc_diatrd
-      hdivn(:,:,:) = hdivdta(:,:,:,2)
-#endif
-
-#if defined key_zdfddm
-      avs(:,:,:)   = avtdta (:,:,:,2)
-#endif
-
-      
-#if defined key_ldfslp
+      
+#if defined key_ldfslp && ! defined key_c1d
       uslp (:,:,:) = uslpdta (:,:,:,2) 
       vslp (:,:,:) = vslpdta (:,:,:,2) 
@@ -969,42 +687,34 @@
       emps(:,:) = emp(:,:) 
       qsr (:,:) = qsrdta (:,:,2) 
-
-#if ! defined key_off_degrad && defined key_traldf_c2d    
-      ahtw(:,:) = ahtwdta(:,:,2)
-#  if defined key_trcldf_eiv
+      IF( l_offbbl ) THEN
+         ahu_bbl(:,:) = bblxdta(:,:,2)
+         ahv_bbl(:,:) = bblydta(:,:,2) 
+      ENDIF
+#if ! defined key_degrad && defined key_traldf_c2d && defined key_traldf_eiv
       aeiw(:,:) = aeiwdta(:,:,2)
-#  endif
-#endif
-      
-#if defined key_off_degrad
+#endif
+      
+#if defined key_degrad
       ahtu(:,:,:) = ahtudta(:,:,:,2)
       ahtv(:,:,:) = ahtvdta(:,:,:,2)
       ahtw(:,:,:) = ahtwdta(:,:,:,2)
-#  if defined key_trcldf_eiv
+#  if defined key_traldf_eiv
       aeiu(:,:,:) = aeiudta(:,:,:,2)
       aeiv(:,:,:) = aeivdta(:,:,:,2)
       aeiw(:,:,:) = aeiwdta(:,:,:,2)
 #  endif
-      
-#endif
-      
-#if defined key_trcbbl_dif ||  defined key_trcbbl_adv
-      bblx(:,:) = bblxdta(:,:,2)
-      bbly(:,:) = bblydta(:,:,2)
-#endif
-
+#endif
+      !
    END SUBROUTINE assign_dyn_data
 
+
    SUBROUTINE linear_interp_dyn_data( pweigh )
       !!----------------------------------------------------------------------
-      !!                    ***  ROUTINE linear_interp_dyn_data  ***
+      !!               ***  ROUTINE linear_interp_dyn_data  ***
       !!
       !! ** Purpose :   linear interpolation of data
-      !!
-      !!----------------------------------------------------------------------
-      !! * Argument
-      REAL(wp), INTENT( in ) ::   pweigh       ! weigh
-
-      !! * Local declarations
+      !!----------------------------------------------------------------------
+      REAL(wp), INTENT(in) ::   pweigh   ! weigh
+      !!
       REAL(wp) :: zweighm1
       !!----------------------------------------------------------------------
@@ -1012,22 +722,13 @@
       zweighm1 = 1. - pweigh
       
-      tn (:,:,:) = zweighm1 * tdta  (:,:,:,1) + pweigh * tdta  (:,:,:,2)
-      sn (:,:,:) = zweighm1 * sdta  (:,:,:,1) + pweigh * sdta  (:,:,:,2)
-      avt(:,:,:) = zweighm1 * avtdta(:,:,:,1) + pweigh * avtdta(:,:,:,2)
+      tsn(:,:,:,jp_tem) = zweighm1 * tdta  (:,:,:,1) + pweigh * tdta  (:,:,:,2)
+      tsn(:,:,:,jp_sal) = zweighm1 * sdta  (:,:,:,1) + pweigh * sdta  (:,:,:,2)
+      avt(:,:,:)        = zweighm1 * avtdta(:,:,:,1) + pweigh * avtdta(:,:,:,2)
       
       un (:,:,:) = zweighm1 * udta  (:,:,:,1) + pweigh * udta  (:,:,:,2) 
       vn (:,:,:) = zweighm1 * vdta  (:,:,:,1) + pweigh * vdta  (:,:,:,2)
       wn (:,:,:) = zweighm1 * wdta  (:,:,:,1) + pweigh * wdta  (:,:,:,2)
-
-#if defined key_trc_diatrd
-      hdivn(:,:,:) = zweighm1 * hdivdta(:,:,:,1) + pweigh * hdivdta(:,:,:,2)
-#endif
-
-#if defined key_zdfddm
-      avs(:,:,:)   = zweighm1 * avtdta (:,:,:,1) + pweigh * avtdta (:,:,:,2)
-#endif
-
-      
-#if defined key_ldfslp
+      
+#if defined key_ldfslp && ! defined key_c1d
       uslp (:,:,:) = zweighm1 * uslpdta (:,:,:,1) + pweigh * uslpdta (:,:,:,2) 
       vslp (:,:,:) = zweighm1 * vslpdta (:,:,:,1) + pweigh * vslpdta (:,:,:,2) 
@@ -1042,17 +743,18 @@
       emps(:,:) = emp(:,:) 
       qsr (:,:) = zweighm1 * qsrdta (:,:,1) + pweigh  * qsrdta (:,:,2) 
-
-#if ! defined key_off_degrad && defined key_traldf_c2d    
-      ahtw(:,:) = zweighm1 * ahtwdta(:,:,1) + pweigh * ahtwdta(:,:,2)
-#  if defined key_trcldf_eiv
+      IF( l_offbbl ) THEN
+         ahu_bbl(:,:) = zweighm1 * bblxdta(:,:,1) +  pweigh  * bblxdta(:,:,2)
+         ahv_bbl(:,:) = zweighm1 * bblydta(:,:,1) +  pweigh  * bblydta(:,:,2)
+      ENDIF
+
+#if ! defined key_degrad && defined key_traldf_c2d && defined key_traldf_eiv 
       aeiw(:,:) = zweighm1 * aeiwdta(:,:,1) + pweigh * aeiwdta(:,:,2)
-#  endif
-#endif
-      
-#if defined key_off_degrad
+#endif
+      
+#if defined key_degrad
       ahtu(:,:,:) = zweighm1 * ahtudta(:,:,:,1) + pweigh * ahtudta(:,:,:,2)
       ahtv(:,:,:) = zweighm1 * ahtvdta(:,:,:,1) + pweigh * ahtvdta(:,:,:,2)
       ahtw(:,:,:) = zweighm1 * ahtwdta(:,:,:,1) + pweigh * ahtwdta(:,:,:,2)
-#  if defined key_trcldf_eiv
+#  if defined key_traldf_eiv
       aeiu(:,:,:) = zweighm1 * aeiudta(:,:,:,1) + pweigh * aeiudta(:,:,:,2)
       aeiv(:,:,:) = zweighm1 * aeivdta(:,:,:,1) + pweigh * aeivdta(:,:,:,2)
@@ -1060,11 +762,7 @@
 #  endif
 #endif
-      
-#if defined key_trcbbl_dif   ||   defined key_trcbbl_adv
-      bblx(:,:) = zweighm1 * bblxdta(:,:,1) + pweigh * bblxdta(:,:,2)
-      bbly(:,:) = zweighm1 * bblydta(:,:,1) + pweigh * bblydta(:,:,2)
-#endif
-
+      !      
    END SUBROUTINE linear_interp_dyn_data
 
+   !!======================================================================
 END MODULE dtadyn
Index: trunk/NEMOGCM/NEMO/OFF_SRC/istate.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OFF_SRC/istate.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OFF_SRC/istate.F90	(revision 2528)
@@ -2,23 +2,19 @@
    !!======================================================================
    !!                     ***  MODULE  istate  ***
-   !! Ocean state   :  initial state setting
+   !! Ocean state   :  initial state setting, off-line case
    !!=====================================================================
+   !! History :  3.3  ! 2010-10  (C. Ethe)  original code
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   istate_init   : initial state setting
+   !!   istate_init   : initial state set to zero
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers 
    USE dom_oce         ! ocean space and time domain 
-   USE ldftra_oce      ! ocean active tracers: lateral physics
-   USE zdf_oce         ! ocean vertical physics
-   USE in_out_manager  ! I/O manager
-   USE phycst          ! physical constants
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC istate_init   ! routine called by step.F90
+   PUBLIC   istate_init   ! routine called by step.F90
 
    !! * Substitutions
@@ -26,9 +22,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL  (2005)
-   !!   $Id$
-   !!   This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-   !!----------------------------------------------------------------------
-
+   !! NEMO/OFF 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!---------------------------------------------------------------------
 CONTAINS
 
@@ -37,34 +32,18 @@
       !!                   ***  ROUTINE istate_init  ***
       !! 
-      !! ** Purpose :   Initialization of the dynamics and tracers.
-      !!
-      !! ** Method  :
-      !!
-      !! History :
-      !!   4.0  !  91-03  ()  Original code
-      !!        !  91-11  (G. Madec)
-      !!   9.0  !  03-09  (G. Madec)  F90: Free form, modules, orthogonality
+      !! ** Purpose :   Initialization to zero of the dynamics and tracers.
       !!----------------------------------------------------------------------
-      !! * Local declarations
-      !!----------------------------------------------------------------------
-
-
-      ! Initialization to zero
-      ! ----------------------
-
-      !     before fields       !       now fields        !      after fields       !
-      ;   un   (:,:,:) = 0.e0   ;   ua   (:,:,:) = 0.e0
-      ;   vn   (:,:,:) = 0.e0   ;   va   (:,:,:) = 0.e0
-      ;                         ;   wn   (:,:,:) = 0.e0   
-      ;   hdivn(:,:,:) = 0.e0   ;
-
-      ;   tn   (:,:,:) = 0.e0   ;   ta   (:,:,:) = 0.e0
-      ;   sn   (:,:,:) = 0.e0   ;   sa   (:,:,:) = 0.e0
-
+      !
+      !     now fields         !     after fields      !
+      un   (:,:,:)   = 0._wp   ;   ua(:,:,:) = 0._wp   !
+      vn   (:,:,:)   = 0._wp   ;   va(:,:,:) = 0._wp   !
+      wn   (:,:,:)   = 0._wp   !                       !
+      hdivn(:,:,:)   = 0._wp   !                       !
+      tsn  (:,:,:,:) = 0._wp   !                       !
+      !
       rhd  (:,:,:) = 0.e0
       rhop (:,:,:) = 0.e0
       rn2  (:,:,:) = 0.e0 
-
-
+      !
    END SUBROUTINE istate_init
 
